Package org.opencv.xfeatures2d

## Class BoostDesc

- java.lang.Object
- - org.opencv.core.Algorithm
  - - org.opencv.features.Feature2D
    - - org.opencv.xfeatures2d.BoostDesc

-     public class BoostDesc
      extends Feature2D

  Class implementing BoostDesc (Learning Image Descriptors with Boosting), described in CITE: Trzcinski13a and CITE: Trzcinski13b. desc type of descriptor to use, BoostDesc::BINBOOST_256 is default (256 bit long dimension) Available types are: BoostDesc::BGM, BoostDesc::BGM_HARD, BoostDesc::BGM_BILINEAR, BoostDesc::LBGM, BoostDesc::BINBOOST_64, BoostDesc::BINBOOST_128, BoostDesc::BINBOOST_256 use_orientation sample patterns using keypoints orientation, enabled by default scale_factor adjust the sampling window of detected keypoints 6.25f is default and fits for KAZE, SURF detected keypoints window ratio 6.75f should be the scale for SIFT detected keypoints window ratio 5.00f should be the scale for AKAZE, MSD, AGAST, FAST, BRISK keypoints window ratio 0.75f should be the scale for ORB keypoints ratio 1.50f was the default in original implementation Note: BGM is the base descriptor where each binary dimension is computed as the output of a single weak learner. BGM_HARD and BGM_BILINEAR refers to same BGM but use different type of gradient binning. In the BGM_HARD that use ASSIGN_HARD binning type the gradient is assigned to the nearest orientation bin. In the BGM_BILINEAR that use ASSIGN_BILINEAR binning type the gradient is assigned to the two neighbouring bins. In the BGM and all other modes that use ASSIGN_SOFT binning type the gradient is assigned to 8 nearest bins according to the cosine value between the gradient angle and the bin center. LBGM (alias FP-Boost) is the floating point extension where each dimension is computed as a linear combination of the weak learner responses. BINBOOST and subvariants are the binary extensions of LBGM where each bit is computed as a thresholded linear combination of a set of weak learners. BoostDesc header files (boostdesc_*.i) was exported from original binaries with export-boostdesc.py script from samples subfolder.

- - ### Field Summary

    - ### Fields inherited from class org.opencv.core.Algorithm

      `nativeObj`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `BoostDesc​(long addr)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static BoostDesc` | `__fromPtr__​(long addr)` |
    `static BoostDesc` | `create()` |
    `static BoostDesc` | `create​(int desc)` |
    `static BoostDesc` | `create​(int desc, boolean use_scale_orientation)` |
    `static BoostDesc` | `create​(int desc, boolean use_scale_orientation, float scale_factor)` |
    `protected void` | `finalize()` |
    `java.lang.String` | `getDefaultName()` | Returns the algorithm string identifier.
    `float` | `getScaleFactor()` |
    `boolean` | `getUseScaleOrientation()` |
    `void` | `setScaleFactor​(float scale_factor)` |
    `void` | `setUseScaleOrientation​(boolean use_scale_orientation)` |

    - ### Methods inherited from class org.opencv.features.Feature2D

      `compute, compute, defaultNorm, descriptorSize, descriptorType, detect, detect, detect, detect, detectAndCompute, detectAndCompute, empty, read, write`

    - ### Methods inherited from class org.opencv.core.Algorithm

      `clear, getNativeObjAddr, save`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BoostDesc

          protected BoostDesc​(long addr)

  - ### Method Detail

    - #### __fromPtr__

          public static BoostDesc __fromPtr__​(long addr)

    - #### create

          public static BoostDesc create​(int desc,
                                         boolean use_scale_orientation,
                                         float scale_factor)

    - #### create

          public static BoostDesc create​(int desc,
                                         boolean use_scale_orientation)

    - #### create

          public static BoostDesc create​(int desc)

    - #### create

          public static BoostDesc create()

    - #### getDefaultName

          public java.lang.String getDefaultName()

      Description copied from class: `Algorithm`
      Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.
      Overrides:
        `getDefaultName` in class `Feature2D`
      Returns:
        automatically generated

    - #### setUseScaleOrientation

          public void setUseScaleOrientation​(boolean use_scale_orientation)

    - #### getUseScaleOrientation

          public boolean getUseScaleOrientation()

    - #### setScaleFactor

          public void setScaleFactor​(float scale_factor)

    - #### getScaleFactor

          public float getScaleFactor()

    - #### finalize

          protected void finalize()
                           throws java.lang.Throwable

      Overrides:
        `finalize` in class `Feature2D`
      Throws:
        `java.lang.Throwable`